#include<iostream.h>
#include<math.h> 
//#include<vector.h>
//#include<stdlib.h>

//typedef vector<int> Ivect;

long sub_design(int a0, int d, int n, int k);
void Design(int n, int k);
int inline valeur(int t, int row, int col, int a0, int d, int n, int k, int width_p);
int true_name(int row,int col,int a0,int d,int n,int k);
int is_valid(int row, int col, int n, int k);
int is_prime(int x);
int next_prime(int x);
int inline gcd(int a, int b);
int inline next_good(int w, int k);

static long total_edges; // total number of edges in design (should be
                         // = n*(n-1)/2 )

int inline min(int a, int b) 
{ 
  return (a<b)? a:b;
}

void Design(int n, int k)
  // Build "good" design on n vertices by k subgraphs
{
 total_edges=0L;
 long total=sub_design(1,1,n,k);
 
 cerr<<"\n\nProduced "<<total<<" subgraphs\n";
 
 cerr<<"Minimum expected number of subgraphs is " 
     << (double)n*(n-1)/k/(k-1)<<endl;
 
 cerr <<"\nAchieved ratio "<< (double) total/((double)n*(n-1)/k/(k-1)) 
      <<" times \n";
 
 cerr <<"\n\nNumber of edges covered " << total_edges << endl;
 cerr <<"Number of edges in the graph "<<(long)n*(n-1)/2L << endl;
};


int new_width(int n, int k)
{
  return next_good((n+k-1)/k,k);
}

int is_k_valid(int n, int k)
{
 if (k<=1)  return 0;
 //cerr << "Is valid ("<<n<<","<<k<<")\n";
  return (new_width(n,k)*k >=n)? 1: 0;
}


long Prognose(int n, int k)
{
  // Should give estimation for total number of produced graphs
 if (n==1) return 0;
 if (n<=k ) return 1;
 else 
   {
    int w=new_width(n,k);
    return (long)w*w+k*Prognose((n+k-1)/k,k);
   }
}

long sub_design(int a0, int d, int n, int global_k)
{ 

  int k=global_k;
  const int width=((n+k-1)/k);
  // const int width_p=next_prime(width);
  const int width_p=next_good(width,k);
 
  long total=0L;
	
  int full_rows=(n%k);
  if (full_rows==0) full_rows=k; 

  if (n <= k) {
    if (n>1)
      {
	int i,sum;
	cout <<"[ ";
	for(i=1,sum=a0; i<=n; i++,sum+=d) cout << sum << " ";
	cout <<"]\n";
	total_edges+=(long)n*(n-1)/2L;
	return 1L;

      }
    else return 0L;
  }
  // Square Design

  //   if (n<= (k-1)*(k-1)) 
  //     return sub_design(a0,d,n,min(k-1,1+(int)ceil(sqrt(n))));
      if (n<= (k-1)*(k-1)) 
      return sub_design(a0,d,n,min(k-1,(int)ceil(sqrt(n+1))));
      
  // Shrink table as narrow as possible 
  
  while ( k>2 && (is_k_valid(n,k-1)) && (new_width(n,k-1) < new_width(n,k))) 
     { 
       //       cerr << "k decreased to: "<<k<< "; n is" <<n<< endl; 
       --k;
     }
     
  /*
  // Increase the height while preserving the width 
  while (k < global_k && (new_width(n,k+1)==new_width(n,k))) k++;
  */

//   while (k>2  && Prognose(n,k-1) < Prognose(n,k))
//     {
//       k--;
//       cerr << "k decreased to: "<<k<< "; n is" <<n<< endl; 
//     }

  int t,col,row,start;
  //  Ivect candidate(k);
  int *candidate=new int[k];
  for(t=0; t<width_p; t++)
    for(col=0; col<width_p; col++)
      {
	//cout<<"[";
	int nonzero=0;      
	for(row=0; row<k; row++) 
	{
		if ((candidate[row]=valeur(t,row,col,a0,d,n,k,width_p))>0) 
		    nonzero++; // Count number of vertices in the design
	}
	if (nonzero>1) {
		cout<<"[ ";
		int val;
		for(row=0; row<k; row++) 
		    if ((val=candidate[row])>0) cout<<val<<" ";
		cout<<"]\n";
		total_edges+=(long)nonzero*(nonzero-1)/2L;
		total++;
	}
	      
	      //  cout << valeur(t,row,col,a0,d,n,k,width_p)<<" ";
	//cout << "]\n";
      }
  for(row=0, start=a0 ; row<full_rows; row++, start+=width) 
    total+=sub_design(start, 1, width, global_k);
  
  for( ; row<k; row++, start+=width-1) 
    total+=sub_design(start, 1, width-1, global_k);
  delete candidate;  
 return total;
}

int inline valeur(int t, int row, int col, int a0, int d, int n, int k, int width)
{
  // Beware, that "width" here is width_p in sub_design()
  // const int width=(n+k-1)/k;
  int old_col=((col-row*t)%width+width)%width;
  return( is_valid(row,old_col,n,k)? true_name(row,old_col,a0,d,n,k):-1);
}

int true_name(int row,int col,int a0,int d,int n,int k)
{
 int full_rows=(n % k), width=(n+k-1)/k;
 if (full_rows==0) full_rows=k;
 //if (col==0) col=width;

 // return (
 // (row < full_rows)?
 // a0+d*(row*width+col) : a0+d*(row*width+col-(row-full_rows+1))
 // );

 // cout << "true name(" <<row<<","<<col<<")\n";
	return (row < full_rows)? 
	    a0+d*(width*row+col) :
	a0+d*(width*row+col-(row-full_rows));

}

int is_valid(int row, int col, int n, int k)
{
	return (col*k+row <n ) ? 1:0;
}


int main()
{
	int n,k;

	//	cerr << next_good(10010,15)<<endl;
	//cerr << next_prime(10010)<<endl;

	cerr << "Enter number of vertices: "; cin >> n;
	cerr << "Enter the limit size of covering graphs: "; cin >>k;

	Design(n,k);

}

int is_prime(int x)
{
	int ub=(int)floor(sqrt(x));
	for(int i=2; i<=ub; i++) if ((x % i)==0) return 0;
	return 1;
}

int next_prime(int x)
{
	if ((x%2)==0) x++;
	while (! is_prime(x)) x+=2;
	return x;
}

int gcd(int a, int b)
{
  if (a>b) return gcd(b,a);
  if (a<0) return gcd(-a,b);
  while (a) {
    int t=a;
    a=b%a;
    b=t;
  }
  return b;

}


int next_good(int w, int k)
{
  // Finds next w which is coprime with 2,3,...,k-1;
  // Expected time log log k (?)
  for(;;)
    {
      int t=1,i ; // t==(k-1)!%w;
      for(i=1; i<k; i++)  t=(t*i)%w ;
      if (gcd(t,w)==1) return w; else w++;
    }
  // Should break when w is a prime or before :)
}



